/* Maths.js
 * Copyright (c) Graham Relf, UK, 2006-2016 */ 

//function Maths () {};
var Maths = new Function ();

Maths.DEG2RAD = Math.PI / 180.0;
Maths.RAD2DEG = 180.0 / Math.PI;

/** Convert angle x (degrees) to lie in range 0..360 */
Maths.in360 = function (xDegs)
{
    var x360 = xDegs % 360.0;
    if (x360 >= 0.0) return x360;
    return x360 + 360.0;
};

/** Get arccos in degrees. */
Maths.acosDegs = 
        function (cos) { return RAD2DEG * Math.acos (cos); };

/** Get arcsin in degrees. */
Maths.asinDegs = 
        function (sin) { return Maths.RAD2DEG * Math.asin (sin); };

/** Get atan2 in degrees. */
Maths.atan2Degs = 
        function (sin, cos) { return Maths.RAD2DEG * Math.atan2 (sin, cos); };

/** Get sine of an angle given in degrees. */
Maths.sinDegs = 
        function (xDegs) { return Math.sin (Maths.DEG2RAD * xDegs); };

/** Get cosine of an angle given in degrees. */
Maths.cosDegs = 
        function (xDegs) { return Math.cos (Maths.DEG2RAD * xDegs); };

/** Get tangent of an angle in degrees. */
Maths.tanDegs = 
        function (xDegs) { return Math.tan (Maths.DEG2RAD * xDegs); };

/** Hyperbolic inverse sine. */
Maths.asinh = 
        function (x) { return Math.log (x + Math.sqrt (x * x + 1.0)); };
