var chart, data;

function initChart ()
{
  chart = document.getElementById ("chart"); // Image
  data = document.getElementById ("data"); // Moveable data display area

  for (var i = 0; i < objects.length; i++)
  {
    var obj = objects [i];
    obj.plotPt = new Point (obj.x, obj.y);
  }

  chart.addEventListener ('mousemove', handleMove, false);
}

function handleMove (event)
{
  var pt = getMousePoint (event);
  var nearest = getNearest (pt);

  if (null != nearest)
  {
    showData (nearest);
  }
}

function getMousePoint (ev)
{
  if (ev.pageX || ev.pageY)
  return new Point (ev.pageX - chart.offsetLeft, ev.pageY - chart.offsetTop);

  return new Point (ev.clientX + document.body.scrollLeft +
                    document.documentElement.scrollLeft - chart.offsetLeft,
	                ev.clientY + document.body.scrollTop  +
                    document.documentElement.scrollTop  - chart.offsetTop);
}

function getNearest (pt)
{
  var minD = 10000;
  var nearest = null;

  for (var i = 0; i < objects.length; i++)
  {
    var obj = objects [i];
    var d = pt.distance (obj.plotPt);

    if (d < minD)
    {
      minD = d;
      nearest = obj;
    }
  }

  if (minD < 50) return nearest;

  data.innerHTML = ''; // Clears
  return null;
} // getNearest

function Point (x, y)
{
  this.x = x;
  this.y = y;
}

Point.prototype.distance = function (other)
{
  var dx = this.x - other.x;
  var dy = this.y - other.y;
  return Math.sqrt (dx * dx + dy * dy);
}

function showData (obj)
{
  mark.style.left = (obj.x + 4) + 'px';
  mark.style.top = (obj.y) + 'px';
  data.style.left = (obj.x) + 'px';
  data.style.top = (obj.y + 30) + 'px';
  var s;
  
  if ("j" in obj) // Ephemeris point:
  {
    s = 'JD' + obj.j + '<br>' + obj.a  + '<br>' + obj.b + '<br>r = ' + obj.r + ' au<br>\u0394 = ' + 
	obj.d + ' au<br>phase = ' + obj.ph + '&deg;';
	if ("el" in obj) { s += '<br>elong = ' + obj.el + '&deg;'; }
	if ("v" in obj) { s += '<br>V = ' + obj.v; }
	data.style.color = '#00f';
  }
  else // Star:
  {
    s = obj.id + '<br>V = ' + obj.v;
    if ("vr" in obj && obj.vr) s += " (variable)";
    if (obj.bv != '-') s += '<br>B-V = ' + obj.bv;
	data.style.color = '#f00';
  }
  
  data.innerHTML = s;
}
